#include <cstdio>
#include <iostream>
#include <vector>
#include <set>
#include <cassert>
#include <cstring>
using namespace std;
const int MAXN = 500, MAXM = 10000, MAXCASES = 50;
int EDGE[500][500];
vector<int> edge[500];
vector<int> output;
main(){
  int cases; cin>>cases;
  assert(0 <= cases && cases <= MAXCASES);
  while(cases--){
    int n, m; cin>>n>>m;
    assert(1 <= n && n <= MAXN);
    assert(0 <= m && m <= MAXM);
    for(int i=0;i<n;++i) memset(EDGE[i],0,sizeof(EDGE[i]));
    for(int i=0;i<m;++i){
      int u,v;
      scanf("%d %d",&u,&v);
      --u, --v;
      edge[u].push_back(v);
      edge[v].push_back(u);
      assert(!EDGE[u][v]);
      assert(u != v);
      EDGE[u][v] = EDGE[v][u] = 1;
    }
    /* A trivial solution */
    /*
    for(int i=0;i<n;++i){
      if(i) printf(" ");
      printf("%d",i+1);
    }
    printf("\n");
    */
    /* End of trivial solution */
 
    /* Testing whether the tester reads line by line instead of just reading the required 
     * number of numbers without paying attention to newline */
    for(int i=0;i<n;++i) output.push_back(i+1);
  }
  /**
   * Output:
   * 1
   * 2 3 .. n_1 1
   * 2 3 .. n_2 1
   * 2 3 .. n_3
   */
  int x; for(int i=output.size()-1;i>=0;--i) {
    if(output[i]==1) {
      x=i;
      break; 
    }
  }
  for(int i=0;i<output.size();++i) {
    if(i != 0 && output[i] != 2) printf(" ");
    printf("%d",output[i]);
    if(output[i]==1) printf("\n");
  }
  printf("\n");
}
 